#pragma once
#include "ThreadJob.h"
#include "define.h"			// RecvMessagePackeẗ̂

class CMySyncObject;		// ̃NX̎gp邱Ƃ錾
class CRingBuff;			// CRingBuffgp邽
class CRecvFileThread;		// CRecvFileThreadgp邽
class CSendFileThread;		// CSendFileThreadgp邽
class CChatMsgThread;		// CChatMsgThreadgp邽

#define	SEND_BUFF_SIZE		(1024 * 64)					// MOobt@̃TCY
#if 1
#define	SENDBUFSIZE			(1024 + sizeof(HeaderRec))	// xɑMTCY̍ől(ʃwb_Ă܂)
#else
#define	SENDBUFSIZE			(1024 * 4)					// TCPőMx1MbpsグƂ͒fЉTCP̃X^bNɔC
														// X^bN(send)ɓnTCY𑝂₷
#endif
#define	RECV_BUFF_SIZE		(1024 * 64)					// MOobt@̃TCY
#define	RCVBUFSIZE			(1024 * 4)					// xɓǂލőMTCY

typedef struct
{
	SOCKET			fdClient;			// ڑς݃\Pbg(accepť)
	CMySyncObject	*pCMySyncObject;	// IuWFNg
	WORD			wUDPSrcPort;		// UDPM|[g/0
	sockaddr		*ai_addr;			// ڑAhX
	size_t			ai_addrlen;			// ڑAhX
} ConnectionInfoRec;


class CSendRecvThread :
	public CThreadJob
{
public:
	CSendRecvThread(ConnectionInfoRec *pConInfo);	// p[^RXgN^œn
	~CSendRecvThread();

	// NX̊֐I[o[Ch
	// C++11ŖIoverrideƂo悤ɂȂ܂
	// NX̓Y֐virtualĂȂƃG[oĂ܂
	UINT DoWork() override;							// DoRecvŎ{ĂeLq
	// Mf[^̐ݒ Rg[pɋITCPőM@\ǉ
	BOOL SetSendData(char *pcData, int iSize, BOOL fForceTCP = FALSE);
	int GetDataForDistributeChat(char **ppcData);	// `bgzpf[^̎擾

	BOOL IsZombie();								// ̃Xbh̓]rԂ

private:
	ConnectionInfoRec *m_pConInfo;				// RXgN^œnp[^i[
												// ̃Xbhs̈悪mۂĂ邱
	BOOL m_fIamZombie;							// ]rԂǂێ
	CRingBuff *m_pCRingBuffSend;				// Mf[^i[pOobt@(TCP)
	CRingBuff *m_pCRingBuffRecv;				// Mf[^i[pOobt@(TCP)
	CRingBuff *m_pCRingBuffSendUDP;				// Mf[^i[pOobt@(UDP)
	CRingBuff *m_pCRingBuffRecvUDP;				// Mf[^i[pOobt@(UDP)

	sockaddr_storage m_PeerAddr;				// (UDPMp)
	socklen_t m_iPeerAddrLen;					// ̒
	SOCKET m_fdUDP;								// f[^M@UDPgp̃\Pbg
	BYTE m_bTarnsMethod;						// 0:TCP 1:UDP

	DWORD	m_dwPrevSentTime;					// O񑗐M(msec)TCP
	DWORD	m_dwSendInterval;					// 񑗐M܂ł̊Ԋu(msec)TCP
	DWORD	m_dwPrevSentTimeUDP;				// O񑗐M(msec)UDP
	DWORD	m_dwSendIntervalUDP;				// 񑗐M܂ł̊Ԋu(msec)UDP

	CRecvFileThread *m_pCRecvFileThread;		// t@CMXbh
	CSendFileThread *m_pCSendFileThread;		// t@CMXbh
	CChatMsgThread *m_pCChatMsgThread;			// `bgbZ[WXbh

	int GetSendData(char **ppcData, int iTcpUdp);	// Mf[^̎擾(TCP/UDPŎQƃobt@؂ւ)

	BOOL RecvTCPData(fd_set *rfds);				// TCPM
	BOOL RecvUDPData(fd_set *rfds);				// UDPM
	BOOL SendTCPData(fd_set *wfds, DWORD dwNow);// TCPM
	BOOL SendUDPData(fd_set *wfds, DWORD dwNow);// UDPM

	int AnalyzeDataRecv(int iTcpUdp);							// Mf[^̉(TCP/UDPŎQƃobt@؂ւ)
	int RecvMessagePacket(HeaderRec *pHeader, int iTcpUdp);		// bZ[WM(TCP/UDPŎQƃobt@؂ւ)
	int RecvFileSendPacket(HeaderRec *pHeader, int iTcpUdp);	// t@CMR}hM֐(TCP/UDPŎQƃobt@؂ւ)
	int RecvFileRecvPacket(HeaderRec *pHeader, int iTcpUdp);	// t@CMR}hM֐(TCP/UDPŎQƃobt@؂ւ)
	int RecvTransMethodPacket(HeaderRec *pHeader);				// f[^M@M֐(TCP̂)
	BOOL MakePeerUDPSockaddr(WORD wPeerPort);					// UDPʐMpɑsockaddr(|[gԍt^)

	DWORD CalcNextSendInterval(int iSentSize);	// 񑗐M܂ł̊Ԋu
	BOOL CanSendNow(DWORD dwNow, int iTcpUdp);	// MėǂɂȂ(TCP/UDPŎQƕϐ؂ւ)

	BOOL KillZombei();							// ̃NXsv(G[)ɂȂXbhj
};

