#pragma once
#include	"stdThread.h"

#define		MAGIC_DATA_LEN		36
#define		MAGIC_STRING		"E2E6F7BF-42B1-4382-AF0B-1F452ED13EB6"
#define		FILE_NAME_LEN		256			// t@C̒
#define		FILE_SIZE_DIGIT		10			// t@CTCY̌

#define		TIMEOUT_FOR_RES		(100000)		// ܂ł̃^CAEgmsec
//-----------------------------------------------------------------------
// `bgbZ[WR}h
// Client->Server, Server->Client
#define		CMD_MSG_DATA			100
//-----------------------------------------------------------------------
// t@CMR}h v/
// Client->Server
#define		CMD_SEND_FILE_START_REQ	200		// MJnv
#define		CMD_SEND_FILE_ING		201		// t@CM
#define		CMD_SEND_FILE_END_REQ	202		// Mv
#define		CMD_SEND_FILE_ABORT_REQ	203		// fv

// Server->Client
#define		CMD_SEND_FILE_START_RES	1200	// MJnvɑ΂鉞
#define		CMD_SEND_FILE_END_RES	1202	// Mvɑ΂鉞
#define		CMD_SEND_FILE_ABORT_RES	1203	// fvɑ΂鉞
//-----------------------------------------------------------------------
// t@CMR}h v/
// Client->Server
#define		CMD_RECV_FILE_SIZE_REQ	300		// MTCYv
#define		CMD_RECV_FILE_START_REQ	301		// MJnv
#define		CMD_RECV_FILE_END_RES	1303	// Mvɑ΂鉞
#define		CMD_RECV_FILE_ABORT_REQ	304		// fv

// Server->Client
#define		CMD_RECV_FILE_SIZE_RES	1300	// MTCYvɑ΂鉞
#define		CMD_RECV_FILE_ABORT_RES	1304	// fvɑ΂鉞
#define		CMD_RECV_FILE_ING		302		// t@CM
#define		CMD_RECV_FILE_END_REQ	303		// Mv
//-----------------------------------------------------------------------
// f[^]@ v/
// Client->Server
#define		CTRL_TRANS_METHOD_REQ	400		// f[^M@v(TCP/UDP)
// Server->Client
#define		CTRL_TRANS_METHOD_RES	1400	// f[^M@(TCP/UDP)
//-----------------------------------------------------------------------

#pragma pack(push ,1)
// ʃwb_
typedef struct
{
	BYTE	bMagicData[MAGIC_DATA_LEN];		// sANZXh~p(WindowsGUIDg܂)
	WORD	wCommand;						// lbg[NI[_[
	WORD	wDataLen;						// lbg[NI[_[
} HeaderRec;

//------------------------------------
// ʃwb_ + f[^ 
//	bZ[WMp\ 
typedef struct
{
	HeaderRec	header;
	BYTE		bMsgData[1];				// null^[~lCg܂܂Ȃf[^
} MsgDataRec;

//------------------------------------
// f[^ 
//	t@CMJnv
//	t@CMTCYv		TCY0őM
//	t@CMTCYv	OK̎̓t@CTCYɒl
//	t@CMJnv			TCY0̂ƂM{Ȃ
typedef struct
{
	char	szFileSize[FILE_SIZE_DIGIT + 1];	// t@C(null^[~l[g܂)
	char	szFileName[FILE_NAME_LEN + 1];		// t@C(null^[~l[g܂)UTF-8
} FileInfoRec;

// ʃwb_ + f[^ 
typedef struct
{
	HeaderRec	header;
	FileInfoRec	FileInfo;
} SendFileStartReqRec, RecvFileSizeReqRec, RecvFileStartReqRec, RecvFileSizeResRec;

//------------------------------------
// f[^ 
//	t@CM(t@C̓rAŌ)
//	t@CM(t@C̓rAŌ)
typedef struct
{
	char	szOffset[FILE_SIZE_DIGIT + 1];		// 擪̈ʒu
	char	szSize[FILE_SIZE_DIGIT + 1];		// f[^̃TCY
} SendFileStatRec;

// ʃwb_ + f[^ 
typedef struct
{
	HeaderRec		header;
	SendFileStatRec	Stat;
	BYTE			bData[1];
} SendFileIngRec, SendFileEndReqRec, RecvFileIngRec, RecvFileEndReqRec;

//------------------------------------
// ʃwb_ + f[^ 
//	t@CMfv
//	t@CMfv
typedef struct
{
	HeaderRec	header;
} SendFileAbortReqRec, RecvFileAbortReqRec;

//------------------------------------
// ʃwb_ + f[^ 
//	t@CMvɑ΂鉞
//	t@CMvɑ΂鉞
typedef struct
{
	HeaderRec	header;
	char		cResCode;						// 1: -1:s ȂǉeR[h
} SendFileResRec, RecvFileResRec;


//------------------------------------
// f[^]@ v
// f[^ 
typedef struct
{
	BYTE		bMethod;						// 0:TCP 1:UDP
	WORD	wUDPSrcPort;						// UDPServer|[gԍ(v0)
} TransMethodInfoRec;

// ʃwb_ + f[^ 
// ClientUDPvoAServer牞TCPȂTCPŃf[^]s
// Server̉UDPȂԂĂ|[gԍNCAg͑MƂĎgp
typedef struct
{
	HeaderRec	header;
	TransMethodInfoRec	TansMethodInfo;
} TransMethodReqRec, TransMethodResRec;

#pragma pack(pop)

